#ifndef __INDEX__
#define __INDEX__
#include "mex.h"

/* Index: dd has to be in increasing order.  Once a Index struct is created
 * with index_new, you'll have to fill in dd yourself. */

typedef struct {
  int nn;
  int *dd;
} Index;

Index index_new(int num);
void index_free(Index ii);
Index index_copy(Index ii);

Index index_readmxarray(const mxArray *marray);
mxArray *index_writemxarray(Index ii);
void index_rewritemxarray(mxArray *marray, Index ii);

int index_length(Index ii);
bool index_isempty(Index ii);

bool index_subindex(Index ii, Index jj);

Index index_union(Index ii, Index jj);
Index index_intersect(Index ii, Index jj);
Index index_diff(Index ii, Index jj);
Index index_xor(Index ii, Index jj);

#endif
