#ifndef __SHAPE_ASGN__
#define __SHAPE_ASGN__
#include "shape.h"

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
  Shape oo, ii;
  Index jj, ss;

  int nn;
  if ( nrhs != 3) 
    mexErrMsgTxt("Need exactly three arguments.");
  ii = shape_readmxarray(prhs[0]);
  jj = index_readmxarray(prhs[1]);
  ss = index_readmxarray(prhs[2]);
  if ( jj.nn != ss.nn ) 
    mexErrMsgTxt("Number of entries in jj and ss must match.");
  oo = shape_asgn(ii,jj,ss.dd);
  plhs[0] = mxDuplicateArray(prhs[0]);
  shape_rewritemxarray(plhs[0],oo); 
  shape_free(ii);
  index_free(jj);
  index_free(ss);
  shape_free(oo);
}

#endif
