#ifndef __TABLE_OP_RECURSIVE2ARG__
#define __TABLE_OP_RECURSIVE2ARG__
#include "table.h"

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray*prhs[])  
{                                                                            
  Table ii, jj, oo;                                                          
  int nn;                                                                    
  if ( nrhs == 0 )                                                           
    mexErrMsgTxt("At least one argument expected.");                         
  oo = table_readmxarray(prhs[0]);                                           
  for ( nn = 1 ; nn < nrhs ; nn ++ ) {                                       
    ii = oo;                                                                 
    jj = table_readmxarray(prhs[nn]);                                        
    if (! shape_consistent(table_shape(ii), table_shape(jj)) )                             
      mexErrMsgTxt("Inconsistent shapes.");                                  
    oo = elemop_name(ii,jj);                                         
    table_sumnorm(oo);                                                       
    table_free(ii);                                                          
    table_free(jj);                                                          
  }
  plhs[0] = mxDuplicateArray(prhs[0]);
  table_rewritemxarray(plhs[0],oo);
  table_free(oo);                                                            
}

#endif
